﻿namespace DotNetAssemblyFinder
{
    /// <summary>
    /// Running options.
    /// </summary>
    internal class Options
    {
        /// <summary>
        /// Target path
        /// </summary>
        public string? Path { get; init; }

        /// <summary>
        /// Output file.
        /// </summary>
        public string? OutputFile { get; init; }

        /// <summary>
        /// Output debug messages.
        /// </summary>
        public bool IsDebug { get; init; }

        /// <summary>
        /// Display usage messages.
        /// </summary>
        public bool IsHelp { get; init; }

        /// <summary>
        /// Find files in sub-folders.
        /// </summary>
        public bool IsRecursive { get; init; }

        /// <summary>
        /// Create options from command line arguments.
        /// </summary>
        /// <param name="args"></param>
        public Options(string[] args)
        {
            for (int i = 0; i < args.Length; i++)
            {
                switch (args[i])
                {
                    case "-d": IsDebug = true; break;
                    case "-h": IsHelp = true; break;
                    /*case "-o":
                        if (i < args.Length - 1)
                            OutputFile = args[++i];
                        break;*/
                    case "-r": IsRecursive = true; break;
                    default: Path ??= args[i]; break;
                }
            }
        }
    }
}
