﻿/*using Mono.Cecil;
using System.Diagnostics;

namespace DotNetAssemblyFinder
{
    /// <summary>
    /// Entrypoint.
    /// </summary>
    internal class Program
    {
        /// <summary>
        /// Cache of parsed TargetFrameworkAttribute.
        /// </summary>
        private static readonly Dictionary<string, string> VER_DICT = [];

        /// <summary>
        /// Entrypoint.
        /// </summary>
        /// <param name="args">Command line arguments</param>
        /// <returns>Result</returns>
        internal static int Main(string[] args)
        {
            try
            {
                Options o = new(args);
                if (o.IsHelp)
                    DisplayUsage(0);
                if (o.Path == null)
                    DisplayUsage(-1);

                if (File.Exists(o.Path))
                {
                    Console.WriteLine(ReadMetadata(o.Path));
                    return 0;
                }

                EnumerationOptions eo = new() { IgnoreInaccessible = true };
                if (o.IsRecursive)
                    eo.RecurseSubdirectories = true;

                int c = 0;
                Stopwatch sw = Stopwatch.StartNew();

                foreach (string s in Directory.EnumerateFiles(o.Path!, "*", eo))
                {
                    string? meta = ReadMetadata(s);
                    if (meta != null)
                        Console.WriteLine($"{++c}. {s}: {meta}");
                }
                
                if (o.IsDebug)
                    Console.Error.WriteLine($"Count: {c}, Elapsed: {sw.Elapsed}");
                    
                return 0;
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.ToString());
                return int.MinValue;
            }
        }

        internal static string? ReadMetadata(string file)
        {
            try
            {
                var d = AssemblyDefinition.ReadAssembly(file);
                return $"{ReadDotNetVersion(d)}, v{d.Name.Version}";
            }
            catch (BadImageFormatException) { return null; }
        }

        internal static string ReadDotNetVersion(AssemblyDefinition asm)
        {
            foreach (var a in asm.CustomAttributes)
            {
                if (a.AttributeType.Name == "TargetFrameworkAttribute")
                {
                    string? ver = a.ConstructorArguments[0].Value.ToString();
                    if (ver == null) return "Unknown";
                    if (VER_DICT.TryGetValue(ver, out var value))
                        return value;
                    string v = ver[(ver.LastIndexOf('v') + 1)..];
                    value = ver[4] switch
                    {
                        'C' => $".NET Core {v}",
                        'F' => $".NET Framework {v}",
                        'S' => $".NET Standard {v}",
                        _ => "Unknown",
                    };
                    VER_DICT.Add(ver, value);
                    return value;
                }
            }
            return "Unknown";
        }

        internal static void DisplayUsage(int error)
        {
            switch (error)
            {
                case -1: Console.WriteLine("Error: No path.\n"); break;
            }
            Environment.Exit(error);
        }
    }
}
*/